## libxeddsa 2.0.0+20221109.06a02c8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(libxeddsa)

include(CTest)

add_subdirectory(ref10)

if (WIN32)
    # On Windows, don't even try to organize the outputs logically
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)

    foreach (OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin)
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin)
        set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin)
    endforeach ()
else (WIN32)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin/static)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin/dynamic)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)

    foreach (OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
        set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin/static)
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin/dynamic)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin)
    endforeach ()
endif (WIN32)

if (WIN32)
    # When using the MinGW generator on Windows, the generated files are prefixed with
    # "lib" and use the extension ".a" instead of ".lib". This is not Windows convention.
    # Using following global settings it is possible to correct most of these issues.
    # Sadly, these global settings don't apply to import libraries. These have to be
    # corrected for each single target.
    set(CMAKE_STATIC_LIBRARY_PREFIX "")
    set(CMAKE_SHARED_LIBRARY_PREFIX "")

    set(CMAKE_STATIC_LIBRARY_SUFFIX ".lib")
endif (WIN32)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")

set(sodium_USE_STATIC_LIBS YES)
find_package(Sodium REQUIRED)
set(sodium_static_INCLUDE_DIR ${sodium_INCLUDE_DIR})

if (NOT DEFINED EMSCRIPTEN)
    set(sodium_USE_STATIC_LIBS NO)
    find_package(Sodium REQUIRED)
    set(sodium_dynamic_INCLUDE_DIR ${sodium_INCLUDE_DIR})

    if (WIN32)
        file(COPY "${sodium_DLL_DEBUG}" DESTINATION "${PROJECT_SOURCE_DIR}/bin/")
        get_filename_component(sodium_DLL_DEBUG_NAME "${sodium_DLL_DEBUG}" NAME)
        file(RENAME "${PROJECT_SOURCE_DIR}/bin/${sodium_DLL_DEBUG_NAME}" "${PROJECT_SOURCE_DIR}/bin/libsodium_debug.dll")

        file(COPY "${sodium_DLL_RELEASE}" DESTINATION "${PROJECT_SOURCE_DIR}/bin/")
        get_filename_component(sodium_DLL_RELEASE_NAME "${sodium_DLL_RELEASE}" NAME)
        file(RENAME "${PROJECT_SOURCE_DIR}/bin/${sodium_DLL_RELEASE_NAME}" "${PROJECT_SOURCE_DIR}/bin/libsodium_release.dll")
    endif ()
endif ()

include_directories(include)
include_directories(ref10/include)
include_directories(${sodium_static_INCLUDE_DIR})
if (NOT DEFINED EMSCRIPTEN)
    include_directories(${sodium_dynamic_INCLUDE_DIR})
endif ()

##########
# xeddsa #
##########

set(xeddsa_sources
    src/ed25519.c
    src/pub_conversion.c
    src/pub_derivation.c
    src/seed_priv_utils.c
    src/utils.c
    src/version.c
    src/x25519.c
    src/xeddsa.c
)

add_library(xeddsa_objects OBJECT ${xeddsa_sources})

set_property(TARGET xeddsa_objects PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(xeddsa_objects PRIVATE SODIUM_DLL_EXPORT)
target_compile_definitions(xeddsa_objects PRIVATE BUILD)

add_library(xeddsa_static STATIC $<TARGET_OBJECTS:xeddsa_objects>)
if (NOT WIN32)
    set_target_properties(xeddsa_static PROPERTIES OUTPUT_NAME xeddsa)
endif ()
target_link_libraries(xeddsa_static PUBLIC
    xeddsa_objects
    crypto_sign_objects
    crypto_hash_objects
    crypto_hashblocks_objects
    crypto_verify_objects
    fastrandombytes_objects
    crypto_rng_objects
    crypto_stream_objects
    crypto_core_objects
    kernelrandombytes_objects
    sodium_static
)

install(TARGETS xeddsa_static)

if (NOT DEFINED EMSCRIPTEN)
    add_library(xeddsa_dynamic SHARED $<TARGET_OBJECTS:xeddsa_objects>)
    set_target_properties(xeddsa_dynamic PROPERTIES OUTPUT_NAME xeddsa)
    target_link_libraries(xeddsa_dynamic PUBLIC
        xeddsa_objects
        crypto_sign_objects
        crypto_hash_objects
        crypto_hashblocks_objects
        crypto_verify_objects
        fastrandombytes_objects
        crypto_rng_objects
        crypto_stream_objects
        crypto_core_objects
        kernelrandombytes_objects
        sodium_shared
    )

    if (WIN32)
        # Correct the import library.
        set_target_properties(xeddsa_dynamic PROPERTIES IMPORT_PREFIX "")
        set_target_properties(xeddsa_dynamic PROPERTIES IMPORT_SUFFIX ".lib")
    endif (WIN32)

    install(TARGETS xeddsa_dynamic)
endif ()

##########################
# xeddsa test executable #
##########################

set(xeddsa_test_sources
    test/test_conversion_uniqueness.c
    test/test_pub_derivation.c
    test/test_signing.c
    test/test.c
)

add_library(xeddsa_test_objects OBJECT ${xeddsa_test_sources})

target_compile_definitions(xeddsa_test_objects PRIVATE SODIUM_DLL_EXPORT)
target_compile_definitions(xeddsa_test_objects PRIVATE BUILD)
target_include_directories(xeddsa_test_objects PRIVATE test)

add_executable(xeddsa_test_static $<TARGET_OBJECTS:xeddsa_test_objects>)
target_include_directories(xeddsa_test_static PRIVATE test)
target_link_libraries(xeddsa_test_static xeddsa_static sodium_static)

if (NOT DEFINED EMSCRIPTEN)
    add_executable(xeddsa_test_dynamic $<TARGET_OBJECTS:xeddsa_test_objects>)
    target_include_directories(xeddsa_test_dynamic PRIVATE test)
    target_link_libraries(xeddsa_test_dynamic xeddsa_dynamic sodium_shared)
endif ()

################
# DEPENDENCIES #
################

target_include_directories(xeddsa_objects PUBLIC
    ref10/crypto_sign
    ref10/crypto_hash
    ref10/crypto_hashblocks
    ref10/crypto_verify
    ref10/fastrandombytes
    ref10/crypto_rng
    ref10/crypto_stream
    ref10/crypto_core
    ref10/kernelrandombytes
)

#########
# TESTS #
#########

if (BUILD_TESTING)
    add_test(NAME xeddsa_test_static COMMAND xeddsa_test_static)

    if (NOT DEFINED EMSCRIPTEN)
        add_test(NAME xeddsa_test_dynamic COMMAND xeddsa_test_dynamic)
    endif ()
endif ()

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	doxygen
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== ref10/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(ref10)

include(CTest)

include(CheckSymbolExists)

if (UNIX)
    if (DEFINED ENV{FORCE_URANDOM})
        set(RANDOM_SOURCE_getentropy  FALSE)
        set(RANDOM_SOURCE_getentropy2 FALSE)
        set(RANDOM_SOURCE_getrandom   FALSE)
        set(RANDOM_SOURCE_getrandom2  FALSE)
        set(RANDOM_SOURCE_getrandom3  FALSE)
        set(RANDOM_SOURCE_urandom     TRUE)
    else ()
        CHECK_SYMBOL_EXISTS(getentropy    "sys/random.h"            RANDOM_SOURCE_getentropy)
        CHECK_SYMBOL_EXISTS(getentropy    "unistd.h"                RANDOM_SOURCE_getentropy2)
        CHECK_SYMBOL_EXISTS(getrandom     "unistd.h;sys/random.h"   RANDOM_SOURCE_getrandom)
        CHECK_SYMBOL_EXISTS(getrandom     "unistd.h;linux/random.h" RANDOM_SOURCE_getrandom2)
        CHECK_SYMBOL_EXISTS(SYS_getrandom "unistd.h;syscall.h"      RANDOM_SOURCE_getrandom3)

        if (RANDOM_SOURCE_getentropy OR RANDOM_SOURCE_getentropy2 OR RANDOM_SOURCE_getrandom OR RANDOM_SOURCE_getrandom2 OR RANDOM_SOURCE_getrandom3)
            set(RANDOM_SOURCE_urandom FALSE)
        else ()
            set(RANDOM_SOURCE_urandom TRUE)
        endif ()
    endif ()
else (UNIX)
    set(RANDOM_SOURCE_getentropy  FALSE)
    set(RANDOM_SOURCE_getentropy2 FALSE)
    set(RANDOM_SOURCE_getrandom   FALSE)
    set(RANDOM_SOURCE_getrandom2  FALSE)
    set(RANDOM_SOURCE_getrandom3  FALSE)
    set(RANDOM_SOURCE_urandom     FALSE)
endif (UNIX)

if (WIN32)
    set(RANDOM_SOURCE_rtlgenrandom TRUE)
else (WIN32)
    set(RANDOM_SOURCE_rtlgenrandom FALSE)
endif (WIN32)

if (NOT (UNIX OR WIN32))
    message(FATAL_ERROR "Unsupported operating system (neither UNIX nor Windows). CMake will exit.")
endif ()

if (WIN32)
    # On Windows, don't even try to organize the outputs logically
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)

    foreach (OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin)
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin)
        set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin)
    endforeach ()
else (WIN32)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin/static)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin/dynamic)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)

    foreach (OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
        set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin/static)
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin/dynamic)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${PROJECT_SOURCE_DIR}/bin)
    endforeach ()
endif (WIN32)

if (WIN32)
    # When using the MinGW generator on Windows, the generated files are prefixed with
    # "lib" and use the extension ".a" instead of ".lib". This is not Windows convention.
    # Using following global settings it is possible to correct most of these issues.
    # Sadly, these global settings don't apply to import libraries. These have to be
    # corrected for each single target.
    set(CMAKE_STATIC_LIBRARY_PREFIX "")
    set(CMAKE_SHARED_LIBRARY_PREFIX "")

    set(CMAKE_STATIC_LIBRARY_SUFFIX ".lib")
endif (WIN32)

include_directories(include)

###############
# crypto_core #
###############

set(crypto_core_sources
    crypto_core/core.c
)

add_library(crypto_core_objects OBJECT ${crypto_core_sources})

set_property(TARGET crypto_core_objects PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(crypto_core_objects PRIVATE BUILD)
target_include_directories(crypto_core_objects PUBLIC  crypto_core)

add_library(crypto_core_static  STATIC $<TARGET_OBJECTS:crypto_core_objects>)
add_library(crypto_core_dynamic SHARED $<TARGET_OBJECTS:crypto_core_objects>)
set_target_properties(crypto_core_dynamic PROPERTIES OUTPUT_NAME crypto_core)
if (NOT WIN32)
    set_target_properties(crypto_core_static PROPERTIES OUTPUT_NAME crypto_core)
endif ()

if (WIN32)
    # Correct the import library.
    set_target_properties(crypto_core_dynamic PROPERTIES IMPORT_PREFIX "")
    set_target_properties(crypto_core_dynamic PROPERTIES IMPORT_SUFFIX ".lib")
endif (WIN32)

###############
# crypto_hash #
###############

set(crypto_hash_sources
    crypto_hash/hash.c
)

add_library(crypto_hash_objects OBJECT ${crypto_hash_sources})

set_property(TARGET crypto_hash_objects PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(crypto_hash_objects PRIVATE BUILD)
target_include_directories(crypto_hash_objects PUBLIC  crypto_hash)

add_library(crypto_hash_static  STATIC $<TARGET_OBJECTS:crypto_hash_objects>)
add_library(crypto_hash_dynamic SHARED $<TARGET_OBJECTS:crypto_hash_objects>)
set_target_properties(crypto_hash_dynamic PROPERTIES OUTPUT_NAME crypto_hash)
if (NOT WIN32)
    set_target_properties(crypto_hash_static PROPERTIES OUTPUT_NAME crypto_hash)
endif ()

if (WIN32)
    # Correct the import library.
    set_target_properties(crypto_hash_dynamic PROPERTIES IMPORT_PREFIX "")
    set_target_properties(crypto_hash_dynamic PROPERTIES IMPORT_SUFFIX ".lib")
endif (WIN32)

#####################
# crypto_hashblocks #
#####################

set(crypto_hashblocks_sources
    crypto_hashblocks/blocks.c
)

add_library(crypto_hashblocks_objects OBJECT ${crypto_hashblocks_sources})

set_property(TARGET crypto_hashblocks_objects PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(crypto_hashblocks_objects PRIVATE BUILD)
target_include_directories(crypto_hashblocks_objects PUBLIC  crypto_hashblocks)

add_library(crypto_hashblocks_static  STATIC $<TARGET_OBJECTS:crypto_hashblocks_objects>)
add_library(crypto_hashblocks_dynamic SHARED $<TARGET_OBJECTS:crypto_hashblocks_objects>)
set_target_properties(crypto_hashblocks_dynamic PROPERTIES OUTPUT_NAME crypto_hashblocks)
if (NOT WIN32)
    set_target_properties(crypto_hashblocks_static PROPERTIES OUTPUT_NAME crypto_hashblocks)
endif ()

if (WIN32)
    # Correct the import library.
    set_target_properties(crypto_hashblocks_dynamic PROPERTIES IMPORT_PREFIX "")
    set_target_properties(crypto_hashblocks_dynamic PROPERTIES IMPORT_SUFFIX ".lib")
endif (WIN32)

##############
# crypto_rng #
##############

set(crypto_rng_sources
    crypto_rng/rng.c
)

add_library(crypto_rng_objects OBJECT ${crypto_rng_sources})

set_property(TARGET crypto_rng_objects PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(crypto_rng_objects PRIVATE BUILD)
target_include_directories(crypto_rng_objects PUBLIC  crypto_rng)

add_library(crypto_rng_static  STATIC $<TARGET_OBJECTS:crypto_rng_objects>)
add_library(crypto_rng_dynamic SHARED $<TARGET_OBJECTS:crypto_rng_objects>)
set_target_properties(crypto_rng_dynamic PROPERTIES OUTPUT_NAME crypto_rng)
if (NOT WIN32)
    set_target_properties(crypto_rng_static PROPERTIES OUTPUT_NAME crypto_rng)
endif ()

if (WIN32)
    # Correct the import library.
    set_target_properties(crypto_rng_dynamic PROPERTIES IMPORT_PREFIX "")
    set_target_properties(crypto_rng_dynamic PROPERTIES IMPORT_SUFFIX ".lib")
endif (WIN32)

#####################
# crypto_scalarmult #
#####################

set(crypto_scalarmult_sources
    crypto_scalarmult/base.c
    crypto_scalarmult/fe_0.c
    crypto_scalarmult/fe_1.c
    crypto_scalarmult/fe_add.c
    crypto_scalarmult/fe_copy.c
    crypto_scalarmult/fe_cswap.c
    crypto_scalarmult/fe_frombytes.c
    crypto_scalarmult/fe_invert.c
    crypto_scalarmult/fe_mul121666.c
    crypto_scalarmult/fe_mul.c
    crypto_scalarmult/fe_sq.c
    crypto_scalarmult/fe_sub.c
    crypto_scalarmult/fe_tobytes.c
    crypto_scalarmult/scalarmult.c
)

add_library(crypto_scalarmult_objects OBJECT ${crypto_scalarmult_sources})

set_property(TARGET crypto_scalarmult_objects PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(crypto_scalarmult_objects PRIVATE BUILD)
target_include_directories(crypto_scalarmult_objects PUBLIC  crypto_scalarmult)

add_library(crypto_scalarmult_static  STATIC $<TARGET_OBJECTS:crypto_scalarmult_objects>)
add_library(crypto_scalarmult_dynamic SHARED $<TARGET_OBJECTS:crypto_scalarmult_objects>)
set_target_properties(crypto_scalarmult_dynamic PROPERTIES OUTPUT_NAME crypto_scalarmult)
if (NOT WIN32)
    set_target_properties(crypto_scalarmult_static PROPERTIES OUTPUT_NAME crypto_scalarmult)
endif ()

if (WIN32)
    # Correct the import library.
    set_target_properties(crypto_scalarmult_dynamic PROPERTIES IMPORT_PREFIX "")
    set_target_properties(crypto_scalarmult_dynamic PROPERTIES IMPORT_SUFFIX ".lib")
endif (WIN32)

###############
# crypto_sign #
###############

set(crypto_sign_sources
    crypto_sign/fe_0.c
    crypto_sign/fe_1.c
    crypto_sign/fe_add.c
    crypto_sign/fe_cmov.c
    crypto_sign/fe_copy.c
    crypto_sign/fe_frombytes.c
    crypto_sign/fe_invert.c
    crypto_sign/fe_isnegative.c
    crypto_sign/fe_isnonzero.c
    crypto_sign/fe_mul.c
    crypto_sign/fe_neg.c
    crypto_sign/fe_pow22523.c
    crypto_sign/fe_sq2.c
    crypto_sign/fe_sq.c
    crypto_sign/fe_sub.c
    crypto_sign/fe_tobytes.c
    crypto_sign/ge_add.c
    crypto_sign/ge_double_scalarmult.c
    crypto_sign/ge_frombytes.c
    crypto_sign/ge_madd.c
    crypto_sign/ge_msub.c
    crypto_sign/ge_p1p1_to_p2.c
    crypto_sign/ge_p1p1_to_p3.c
    crypto_sign/ge_p2_0.c
    crypto_sign/ge_p2_dbl.c
    crypto_sign/ge_p3_0.c
    crypto_sign/ge_p3_dbl.c
    crypto_sign/ge_p3_tobytes.c
    crypto_sign/ge_p3_to_cached.c
    crypto_sign/ge_p3_to_p2.c
    crypto_sign/ge_precomp_0.c
    crypto_sign/ge_scalarmult_base.c
    crypto_sign/ge_sub.c
    crypto_sign/ge_tobytes.c
    crypto_sign/keypair.c
    crypto_sign/open.c
    crypto_sign/sc_muladd.c
    crypto_sign/sc_reduce.c
    crypto_sign/sign.c
)

add_library(crypto_sign_objects OBJECT ${crypto_sign_sources})

set_property(TARGET crypto_sign_objects PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(crypto_sign_objects PRIVATE BUILD)
target_include_directories(crypto_sign_objects PUBLIC  crypto_sign)

add_library(crypto_sign_static  STATIC $<TARGET_OBJECTS:crypto_sign_objects>)
add_library(crypto_sign_dynamic SHARED $<TARGET_OBJECTS:crypto_sign_objects>)
set_target_properties(crypto_sign_dynamic PROPERTIES OUTPUT_NAME crypto_sign)
if (NOT WIN32)
    set_target_properties(crypto_sign_static PROPERTIES OUTPUT_NAME crypto_sign)
endif ()

if (WIN32)
    # Correct the import library.
    set_target_properties(crypto_sign_dynamic PROPERTIES IMPORT_PREFIX "")
    set_target_properties(crypto_sign_dynamic PROPERTIES IMPORT_SUFFIX ".lib")
endif (WIN32)

#################
# crypto_stream #
#################

set(crypto_stream_sources
    crypto_stream/stream.c
    crypto_stream/xor.c
)

add_library(crypto_stream_objects OBJECT ${crypto_stream_sources})

set_property(TARGET crypto_stream_objects PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(crypto_stream_objects PRIVATE BUILD)
target_include_directories(crypto_stream_objects PUBLIC  crypto_stream)

add_library(crypto_stream_static  STATIC $<TARGET_OBJECTS:crypto_stream_objects>)
add_library(crypto_stream_dynamic SHARED $<TARGET_OBJECTS:crypto_stream_objects>)
set_target_properties(crypto_stream_dynamic PROPERTIES OUTPUT_NAME crypto_stream)
if (NOT WIN32)
    set_target_properties(crypto_stream_static PROPERTIES OUTPUT_NAME crypto_stream)
endif ()

if (WIN32)
    # Correct the import library.
    set_target_properties(crypto_stream_dynamic PROPERTIES IMPORT_PREFIX "")
    set_target_properties(crypto_stream_dynamic PROPERTIES IMPORT_SUFFIX ".lib")
endif (WIN32)

#################
# crypto_verify #
#################

set(crypto_verify_sources
    crypto_verify/verify.c
)

=== debian/changelog ===
libxeddsa (2.0.0+20221109.06a02c8-2) unstable; urgency=medium

  * Use a map file

 -- Martin <debacle@debian.org>  Sun, 04 Dec 2022 07:12:13 +0000

libxeddsa (2.0.0+20221109.06a02c8-1) unstable; urgency=medium

  * Initial package (Closes: #1023293)

 -- Martin <debacle@debian.org>  Thu, 24 Nov 2022 00:00:21 +0000

=== debian/control ===
Source: libxeddsa
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: Martin <debacle@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
	       debhelper-compat (= 13),
	       doxygen,
	       libsodium-dev,
	       patchelf,
	       pkg-config,
	       python3-breathe,
	       python3-sphinx,
	       python3-sphinx-rtd-theme,
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/xmpp-team/libxeddsa
Vcs-Git: https://salsa.debian.org/xmpp-team/libxeddsa.git
Homepage: https://github.com/Syndace/libxeddsa
Rules-Requires-Root: no

Package: libxeddsa-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libxeddsa2 (= ${binary:Version}),
         ${misc:Depends},
	 ${sphinxdoc:Depends},
Pre-Depends: ${misc:Pre-Depends}
Description: toolkit around Curve25519 and Ed25519 key pairs - development files
 A toolkit around Curve25519 and Ed25519 key pairs, with a focus on
 conversion between the two. Offers:
 .
   - Conversion between Curve25519 and Ed25519 public keys
   - Extraction of private keys from seeds
   - Ed25519 digital signing using seeds or private keys
   - Ed25519 digital signature verification
   - X25519 Diffie-Hellman key agreement
 .
 This package contains the development files.

Package: libxeddsa2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: toolkit around Curve25519 and Ed25519 key pairs - shared library
 A toolkit around Curve25519 and Ed25519 key pairs, with a focus on
 conversion between the two. Offers:
 .
   - Conversion between Curve25519 and Ed25519 public keys
   - Extraction of private keys from seeds
   - Ed25519 digital signing using seeds or private keys
   - Ed25519 digital signature verification
   - X25519 Diffie-Hellman key agreement
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake --with sphinxdoc

execute_after_dh_auto_build:
	( cd bin/dynamic/; \
          mv libxeddsa.so libxeddsa.so.${DEB_VERSION_UPSTREAM}; \
	  MAJOR=$$(echo ${DEB_VERSION_UPSTREAM} | sed 's/\..*//'); \
          patchelf --set-soname libxeddsa.so.$${MAJOR} libxeddsa.so.${DEB_VERSION_UPSTREAM}; \
	  ln -s libxeddsa.so.${DEB_VERSION_UPSTREAM} libxeddsa.so.$${MAJOR}; \
	  ln -s libxeddsa.so.${DEB_VERSION_UPSTREAM} libxeddsa.so )
	cd docs && $(MAKE) html

override_dh_dwz: # override dwz as it breaks on shlibs edited by patchelf

## libxeddsa 2.0.0+20231128.d725c81

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(libxeddsa)
+project(libxeddsa VERSION 2.0.0 LANGUAGES C)
 
 include(CTest)
 
@@ -44,14 +44,12 @@
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")
 
-set(sodium_USE_STATIC_LIBS YES)
-find_package(Sodium REQUIRED)
-set(sodium_static_INCLUDE_DIR ${sodium_INCLUDE_DIR})
-
-if (NOT DEFINED EMSCRIPTEN)
+if (DEFINED EMSCRIPTEN)
+    set(sodium_USE_STATIC_LIBS YES)
+    find_package(Sodium REQUIRED)
+else ()
     set(sodium_USE_STATIC_LIBS NO)
     find_package(Sodium REQUIRED)
-    set(sodium_dynamic_INCLUDE_DIR ${sodium_INCLUDE_DIR})
 
     if (WIN32)
         file(COPY "${sodium_DLL_DEBUG}" DESTINATION "${PROJECT_SOURCE_DIR}/bin/")
@@ -66,10 +64,7 @@
 
 include_directories(include)
 include_directories(ref10/include)
-include_directories(${sodium_static_INCLUDE_DIR})
-if (NOT DEFINED EMSCRIPTEN)
-    include_directories(${sodium_dynamic_INCLUDE_DIR})
-endif ()
+include_directories(${sodium_INCLUDE_DIR})
 
 ##########
 # xeddsa #
@@ -107,7 +102,7 @@
     crypto_stream_objects
     crypto_core_objects
     kernelrandombytes_objects
-    sodium_static
+    sodium
 )
 
 install(TARGETS xeddsa_static)
@@ -115,6 +110,11 @@
 if (NOT DEFINED EMSCRIPTEN)
     add_library(xeddsa_dynamic SHARED $<TARGET_OBJECTS:xeddsa_objects>)
     set_target_properties(xeddsa_dynamic PROPERTIES OUTPUT_NAME xeddsa)
+    set_target_properties(xeddsa_dynamic PROPERTIES
+       VERSION ${CMAKE_PROJECT_VERSION}
+       SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
+    )
+
     target_link_libraries(xeddsa_dynamic PUBLIC
         xeddsa_objects
         crypto_sign_objects
@@ -126,7 +126,7 @@
         crypto_stream_objects
         crypto_core_objects
         kernelrandombytes_objects
-        sodium_shared
+        sodium
     )
 
     if (WIN32)
@@ -157,12 +157,12 @@
 
 add_executable(xeddsa_test_static $<TARGET_OBJECTS:xeddsa_test_objects>)
 target_include_directories(xeddsa_test_static PRIVATE test)
-target_link_libraries(xeddsa_test_static xeddsa_static sodium_static)
+target_link_libraries(xeddsa_test_static xeddsa_static sodium)
 
 if (NOT DEFINED EMSCRIPTEN)
     add_executable(xeddsa_test_dynamic $<TARGET_OBJECTS:xeddsa_test_objects>)
     target_include_directories(xeddsa_test_dynamic PRIVATE test)
-    target_link_libraries(xeddsa_test_dynamic xeddsa_dynamic sodium_shared)
+    target_link_libraries(xeddsa_test_dynamic xeddsa_dynamic sodium)
 endif ()
 
 ################

=== ref10/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(ref10)
+project(ref10 LANGUAGES C)
 
 include(CTest)
 
@@ -331,5 +331,3 @@
 
 set(crypto_verify_sources
     crypto_verify/verify.c
-)
-

=== debian/changelog ===
libxeddsa (2.0.0+20231128.d725c81-1) unstable; urgency=medium

  * New upstream snapshot
  * Add debian/clean (Closes: #1048182)

 -- Martin <debacle@debian.org>  Thu, 26 Dec 2024 22:51:03 +0000

libxeddsa (2.0.0+20221109.06a02c8-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062732

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 07:17:19 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Uploaders: Martin <debacle@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: cmake,
+Build-Depends: dpkg-dev (>= 1.22.5),
+	       cmake,
 	       debhelper-compat (= 13),
 	       doxygen,
 	       libsodium-dev,
@@ -22,8 +23,8 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libxeddsa2 (= ${binary:Version}),
-         ${misc:Depends},
+Depends: libxeddsa2t64 (= ${binary:Version}),
+	 ${misc:Depends},
 	 ${sphinxdoc:Depends},
 Pre-Depends: ${misc:Pre-Depends}
 Description: toolkit around Curve25519 and Ed25519 key pairs - development files
@@ -38,7 +39,10 @@
  .
  This package contains the development files.
 
-Package: libxeddsa2
+Package: libxeddsa2t64
+Provides: ${t64:Provides}
+Replaces: libxeddsa2
+Breaks: libxeddsa2 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake --with sphinxdoc

execute_after_dh_auto_build:
	( cd bin/dynamic/; \
	  VERSION_UPSTREAM=$$(echo ${DEB_VERSION_UPSTREAM} | sed 's/\+.*//'); \
	  MAJOR=$$(echo ${DEB_VERSION_UPSTREAM} | sed 's/\..*//'); \
          patchelf --set-soname libxeddsa.so.$${MAJOR} libxeddsa.so.$${VERSION_UPSTREAM} )
	cd docs && $(MAKE) html

override_dh_dwz: # override dwz as it breaks on shlibs edited by patchelf
